
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Csv_import_jobsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const csv_import_jobs = await db.csv_import_jobs.create(
            {
                id: data.id || undefined,
        
        job_name: data.job_name
        ||
        null
            ,
            
        target_entity: data.target_entity
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        requested_at: data.requested_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
        total_rows: data.total_rows
        ||
        null
            ,
            
        success_rows: data.success_rows
        ||
        null
            ,
            
        error_rows: data.error_rows
        ||
        null
            ,
            
        error_report: data.error_report
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await csv_import_jobs.setTenant( data.tenant || null, {
            transaction,
        });
        
        await csv_import_jobs.setRequested_by( data.requested_by || null, {
            transaction,
        });
        
        await csv_import_jobs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.csv_import_jobs.getTableName(),
                belongsToColumn: 'source_file',
                belongsToId: csv_import_jobs.id,
            },
            data.source_file,
            options,
        );
        

        return csv_import_jobs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const csv_import_jobsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                job_name: item.job_name
            ||
            null
            ,
            
                target_entity: item.target_entity
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                requested_at: item.requested_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
                total_rows: item.total_rows
            ||
            null
            ,
            
                success_rows: item.success_rows
            ||
            null
            ,
            
                error_rows: item.error_rows
            ||
            null
            ,
            
                error_report: item.error_report
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const csv_import_jobs = await db.csv_import_jobs.bulkCreate(csv_import_jobsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < csv_import_jobs.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.csv_import_jobs.getTableName(),
                    belongsToColumn: 'source_file',
                    belongsToId: csv_import_jobs[i].id,
                },
                data[i].source_file,
                options,
            );
        }
        

        return csv_import_jobs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const csv_import_jobs = await db.csv_import_jobs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.job_name !== undefined) updatePayload.job_name = data.job_name;
        
        
        if (data.target_entity !== undefined) updatePayload.target_entity = data.target_entity;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.requested_at !== undefined) updatePayload.requested_at = data.requested_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        if (data.total_rows !== undefined) updatePayload.total_rows = data.total_rows;
        
        
        if (data.success_rows !== undefined) updatePayload.success_rows = data.success_rows;
        
        
        if (data.error_rows !== undefined) updatePayload.error_rows = data.error_rows;
        
        
        if (data.error_report !== undefined) updatePayload.error_report = data.error_report;
        
        
        updatePayload.updatedById = currentUser.id;

        await csv_import_jobs.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await csv_import_jobs.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.requested_by !== undefined) {
            await csv_import_jobs.setRequested_by(
              
              data.requested_by,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await csv_import_jobs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.csv_import_jobs.getTableName(),
                belongsToColumn: 'source_file',
                belongsToId: csv_import_jobs.id,
            },
            data.source_file,
            options,
        );
        

        return csv_import_jobs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const csv_import_jobs = await db.csv_import_jobs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of csv_import_jobs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of csv_import_jobs) {
                await record.destroy({transaction});
            }
        });


        return csv_import_jobs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const csv_import_jobs = await db.csv_import_jobs.findByPk(id, options);

        await csv_import_jobs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await csv_import_jobs.destroy({
            transaction
        });

        return csv_import_jobs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const csv_import_jobs = await db.csv_import_jobs.findOne(
            { where },
            { transaction },
        );

        if (!csv_import_jobs) {
            return csv_import_jobs;
        }

        const output = csv_import_jobs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.tenant = await csv_import_jobs.getTenant({
            transaction
        });
        
        
        output.source_file = await csv_import_jobs.getSource_file({
            transaction
        });
        
        
        output.requested_by = await csv_import_jobs.getRequested_by({
            transaction
        });
        
        
        output.organizations = await csv_import_jobs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'requested_by',
        
        where: filter.requested_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requested_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requested_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'source_file',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.job_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'csv_import_jobs',
                        'job_name',
                        filter.job_name,
                    ),
                };
            }
            
            if (filter.error_report) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'csv_import_jobs',
                        'error_report',
                        filter.error_report,
                    ),
                };
            }
            

            
            

            
            if (filter.requested_atRange) {
                const [start, end] = filter.requested_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_rowsRange) {
                const [start, end] = filter.total_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_rows: {
                    ...where.total_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_rows: {
                    ...where.total_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.success_rowsRange) {
                const [start, end] = filter.success_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    success_rows: {
                    ...where.success_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    success_rows: {
                    ...where.success_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.error_rowsRange) {
                const [start, end] = filter.error_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    error_rows: {
                    ...where.error_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    error_rows: {
                    ...where.error_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.target_entity) {
                where = {
                    ...where,
                target_entity: filter.target_entity,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.csv_import_jobs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'csv_import_jobs',
                        'job_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.csv_import_jobs.findAll({
            attributes: [ 'id', 'job_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['job_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.job_name,
        }));
    }

    
};

